#include <syidef.h>
#include <stdlib.h>
#include <starlet.h>
#include <iledef.h>
#include <stdio.h>
#include <descrip.h>
#include <lib$routines.h>
#include <iosbdef.h>
#include <iccdef.h>

#include <ssdef.h>
#include <stsdef.h>

#include <string.h>

#define check(STS) if(!$VMS_STATUS_SUCCESS(STS)) sys$exit(STS)
#define MAX_NODE_NAME 15
#define MAX_BUFF 1000
#define NUM_MSGS 1000000

int  main(int argc,char **args) {
  int         status;
  int         i;
  int         a_handle;
  int         c_handle;

  $DESCRIPTOR (ra_name, "VERY_SIMPLE_SERVER");
  $DESCRIPTOR (node_pmt, "Server node: ");
  static char node[MAX_NODE_NAME];
  struct dsc$descriptor_s r_node =
  {sizeof (node),
   DSC$K_DTYPE_T, DSC$K_CLASS_S, node};
  int         acc_len;
  struct _ios_icc icc_iosb;
  char        info[MAX_BUFF];

  if (argc < 2) {
    /* Get remote node name to connect with. */
    status = lib$get_input (&r_node, &node_pmt, &r_node.dsc$w_length);
    check (status);
  } else {
    strcpy(node, args[1]);
    r_node.dsc$w_length = strlen(node);
  }


  /* Connect. */
  printf ("connect request.\n");
  status = sys$icc_connectw (&icc_iosb, 0, 0, ICC$C_DFLT_ASSOC_HANDLE,
			     &c_handle,
		     &ra_name, &r_node, 0, 0, 0, info, sizeof (info), 0, 0);
  check (status);
  check (icc_iosb.ios_icc$w_status);
  /* Display the value received in the return buffer. */
  printf ("Connect buffer data: \"%s\"\n", info);

  status = lib$init_timer(0);
  check (status);

  /* Accept and display the first NUM_MSGS messages sent to us. */
  for (i = 0; i < NUM_MSGS; i++) {
    status = sys$icc_receivew(c_handle, &icc_iosb, 0, 0, info, sizeof (info));
    check (status);
    check (icc_iosb.ios_icc$w_status);
/*
    printf ("Read %d bytes\n", icc_iosb.ios_icc$l_rcv_len);
    printf ("Read \"%s\"\n", info);
*/
  }

  status = lib$show_timer(0, 0, 0, 0);
  check (status);

/* Disconnect. */
  status = sys$icc_disconnect (c_handle, &icc_iosb, 0, 0, 0, 0);
  if (status != SS$_DISCONNECT) {
    check (status);
    check (icc_iosb.ios_icc$w_status);
  }
  return (EXIT_SUCCESS);
}
